<template>
    <v-row justify="center">
        <v-col>
            <v-card>
                <v-card-title>
                    {{ $t('product', [$tc('variant', 2)]) }}

                    <v-spacer></v-spacer>

                    <v-btn color="primary" @click="addVariant">
                        <v-icon left>mdi-plus</v-icon>
                        <span>{{ $t('variant') }}</span>
                    </v-btn>
                </v-card-title>

                <v-card-text>
                    <v-container class="white pa-5">
                        <v-row v-for="variant in variants" :key="variant.id">

                            <div class="col flex-grow-0 flex-shrink-1 align-self-center action">
                                <v-btn
                                    small
                                    icon
                                    color="primary"
                                    @click="edit(variant)"
                                >
                                    <v-icon>mdi-pencil</v-icon>
                                </v-btn>

                                <v-btn
                                    small
                                    icon
                                    color="error"
                                    :disabled="!variant.removable || !!variant.products_count"
                                    @click="remove(variant)"
                                >
                                    <v-icon>mdi-delete</v-icon>
                                </v-btn>
                            </div>

                            <v-col class="d-flex flex-grow-1 flex-shrink-0 align-center">
                                <v-text-field
                                    v-model="variant.name"
                                    hide-details
                                    outlined
                                    disabled
                                >
                                </v-text-field>
                            </v-col>

                            <v-col class="flex-grow-1 flex-shrink-0">
                                <v-chip-group column>
                                    <v-chip
                                        v-for="option in variant.options"
                                        :key="option.id"
                                    >
                                        <span>{{ option.name }}</span>
                                    </v-chip>
                                </v-chip-group>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>
            </v-card>
        </v-col>

        <v-dialog
            v-if="creating"
            v-model="createDialog"
            persistent
            max-width="610"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('create_form', [$t('prod_variant')]) }}
                </v-card-title>

                <v-card-text>
                    <v-container>
                        <ValidationObserver ref="createObserver" v-slot="{ validate, reset }">
                            <v-row>
                                <v-col>
                                    <div class="field-label">{{ $t('variant') }}</div>
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="creating.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </v-col>
                            </v-row>

                            <v-row>
                                <v-col cols="6" v-for="(option, index) in creating.options" :key="option.nonce">
                                    <div class="d-inline-block">
                                        <v-btn
                                            color="error"
                                            @click="removeNewVariantOption(option.nonce)"
                                            icon
                                        >
                                            <v-icon large>mdi-minus-circle</v-icon>
                                        </v-btn>
                                    </div>
                                    <div class="d-inline-block">
                                        <div class="field-label">{{ $tc('option', 2) }}</div>
                                        <ValidationProvider v-slot="{ errors }" :name="$tc('option', 2)" rules="required">
                                            <v-text-field
                                                v-model="option.name"
                                                :error-messages="errors"
                                                hide-details="auto"
                                                outlined
                                            >
                                            </v-text-field>
                                        </ValidationProvider>
                                    </div>
                                </v-col>

                                <v-col>
                                    <div class="d-inline-block">
                                        <v-btn icon color="primary" @click="addNewVariantOption">
                                            <v-icon large>mdi-plus-circle</v-icon>
                                        </v-btn>
                                    </div>
                                    <div class="d-inline-block">
                                        <div class="field-label">{{ $tc('option', 2) }}</div>
                                        <v-text-field
                                            v-model="newOption"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </div>
                                </v-col>
                            </v-row>
                        </ValidationObserver>
                    </v-container>
                </v-card-text>

                <v-card-actions class="py-5 justify-center">
                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="cancelCreateVariant"
                    >
                        <v-icon left>mdi-window-close</v-icon>
                        {{ $t('cancel') }}
                    </v-btn>
                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="createVariant"
                    >
                        <v-icon left>mdi-plus</v-icon>
                        {{ $t('create') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="editing"
            v-model="editDialog"
            persistent
            max-width="610"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('edit_', [$tc('variant', 2)]) }}
                </v-card-title>

                <v-card-text>
                    <v-container>
                        <ValidationObserver ref="updateObserver" v-slot="{ validate, reset }">
                            <v-row>
                                <v-col>
                                    <div class="field-label">{{ $t('variant') }}</div>
                                    <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                        <v-text-field
                                            v-model="editing.name"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </v-col>
                            </v-row>

                            <v-row>
                                <v-col cols="6" v-for="option in editingOptions" :key="option.id || option.nonce">
                                    <div class="d-inline-block">
                                        <v-btn
                                            color="error"
                                            :disabled="!option.removable || !!option.products_count"
                                            @click="removeOption(option.id || option.nonce)"
                                            icon
                                        >
                                            <v-icon large>mdi-minus-circle</v-icon>
                                        </v-btn>
                                    </div>
                                    <div class="d-inline-block">
                                        <div class="field-label">{{ $tc('option', 2) }}</div>
                                        <ValidationProvider v-slot="{ errors }" :name="$tc('option', 2)" rules="required">
                                            <v-text-field
                                                v-model="option.name"
                                                :error-messages="errors"
                                                hide-details="auto"
                                                outlined
                                            >
                                            </v-text-field>
                                        </ValidationProvider>
                                    </div>
                                </v-col>

                                <v-col>
                                    <div class="d-inline-block">
                                        <v-btn icon color="primary" @click="addOption">
                                            <v-icon large>mdi-plus-circle</v-icon>
                                        </v-btn>
                                    </div>
                                    <div class="d-inline-block">
                                        <div class="field-label">{{ $tc('option', 2) }}</div>
                                        <v-text-field
                                            v-model="newOption"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </div>
                                </v-col>
                            </v-row>
                        </ValidationObserver>
                    </v-container>
                </v-card-text>

                <v-card-actions class="py-5 justify-center">
                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="cancel"
                    >
                        <v-icon left>mdi-window-close</v-icon>
                        {{ $t('cancel') }}
                    </v-btn>
                    <v-btn
                        class="primary"
                        color="white"
                        :loading="loading"
                        @click="save"
                    >
                        <v-icon left>mdi-content-save</v-icon>
                        {{ $t('save') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="deleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$t('product')]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="pt-2 mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        :loading="loading"
                        @click="cancelDeleteVariant"
                        text
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        :loading="loading"
                        @click="deleteVariant"
                        text
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import shortid from "shortid";
    import { ValidationObserver, ValidationProvider } from 'vee-validate';

    export default {
        name: "ProductVariant",
        components: {ValidationObserver, ValidationProvider},

        data: () => ({
            creating: null,
            deleting: null,
            newOption: null,
            createDialog: false,
            editDialog: false,
            deleteDialog: false,
            editing: null,
            editingOptions: [],
            removedOptions: [],
            loading: true,
            variants: []
        }),

        mounted() {
            this.fetchVariants()
                .then(data => {
                    this.loading = false;
                    this.variants = data;
                });
        },

        methods: {
            fetchVariants() {
                return new Promise((resolve, reject) => {
                    axios.get('api/products/variants')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                });
            },

            save() {
                this.loading = true;

                this.$refs.updateObserver.validate()
                    .then(valid => {
                        if(valid) {
                            axios.put(`api/products/variants/${this.editing.id}`, {
                                name: this.editing.name,
                                options: this.editingOptions,
                                removed_options: this.removedOptions.length ? this.removedOptions : undefined
                            })
                                .then(({ data }) => {
                                    const index = this.variants.findIndex(v => v.id === data.id);
                                    this.variants[index] = data;
                                    this.loading = false;
                                    this.cancel();
                                })
                                .catch(error => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            cancel() {
                this.editing = null;
                this.editingOptions = [];
                this.newOption = '';
                this.removedOptions = [];
                this.editDialog = false;
                this.$refs.updateObserver.reset();
            },

            edit(variant) {
                this.editDialog = true;
                this.editing = {
                    id: variant.id,
                    name: variant.name
                };

                this.editingOptions = _.cloneDeep(variant.options);
            },

            addOption() {
                if(this.newOption) {
                    this.editingOptions.push({
                        nonce: shortid.generate(),
                        name: this.newOption,
                        removable: true,
                        product_count: 0
                    });

                    this.newOption = '';
                }
            },

            removeOption(id) {
                const index = this.editingOptions.findIndex(o => o.id === id || o.nonce === id);

                if(this.editingOptions[index].id) {
                    this.removedOptions.push(id);
                }

                this.editingOptions.splice(index, 1);
            },

            remove(variant) {
                this.deleting = variant;
                this.deleteDialog = true;
            },

            cancelDeleteVariant() {
                this.deleting = null;
                this.deleteDialog = false;
            },

            deleteVariant() {
                this.loading = true;

                axios.delete('api/products/variants/' + this.deleting.id)
                    .then(({ data }) => {
                        const index = this.variants.findIndex(v => v.id === this.deleting.id);
                        this.variants.splice(index, 1);
                        this.loading = false;
                        this.cancelDeleteVariant();
                    })
                    .catch(error => {
                        this.loading = false;
                    })
            },

            addVariant() {
                this.creating = {
                    name: '',
                    options: []
                };

                this.createDialog = true;
            },

            createVariant() {
                this.loading = true;

                this.$refs.createObserver.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/products/variants', this.creating)
                                .then(({ data }) => {
                                    this.loading = false;
                                    this.variants.push(data);
                                    this.cancelCreateVariant();
                                })
                                .catch(error => {
                                    this.loading = false;
                                })
                        }
                        else {
                            this.loading = false;
                        }
                    });
            },

            cancelCreateVariant() {
                this.creating = null;
                this.createDialog = false;
            },

            removeNewVariantOption(nonce) {
                const index = this.creating.options.findIndex(o => o.nonce === nonce);

                if(index !== undefined) {
                    this.creating.options.splice(index, 1);
                }
            },

            addNewVariantOption() {
                if(this.newOption) {
                    this.creating.options.push({
                        nonce: shortid.generate(),
                        name: this.newOption,
                        removable: true,
                        product_count: 0
                    });

                    this.newOption = '';
                }
            }
        }
    }
</script>

<style scoped>
    .action {
        min-width: 90px
    }
</style>
